/**
  ******************************************************************************
  * @file    TIM1/TIM1_6Steps/stm8l15x_it.c
  * @author  MCD Application Team
  * @version V1.5.2
  * @date    30-September-2014
  * @brief   Main Interrupt Service Routines.
  *          This file provides template for all peripherals interrupt service routine.
  ******************************************************************************
  */ 

// Includes ------------------------------------------------------------------
#include "stm8l15x_it.h"

 // @addtogroup STM8L15x_StdPeriph_Examples

 // @addtogroup TIM1_6Steps

// Private typedef -----------------------------------------------------------
// Private define ------------------------------------------------------------
// Private macro -------------------------------------------------------------
// Private variables ---------------------------------------------------------
uint8_t TimeCounter = 0;
uint8_t step = 1;

// Private function prototypes -----------------------------------------------
// Private functions ---------------------------------------------------------
// Public functions ----------------------------------------------------------

#ifdef _COSMIC_
/**
  * @brief Dummy interrupt routine
  * @param  None
  * @retval None
  */
INTERRUPT_HANDLER(NonHandledInterrupt, 0)
{
  /* In order to detect unexpected events during development,
     it is recommended to set a breakpoint on the following instruction.
  */
}
#endif

/**
  * @brief TRAP interrupt routine
  * @param  None
  * @retval None
  */
INTERRUPT_HANDLER_TRAP(TRAP_IRQHandler)
{
  /* In order to detect unexpected events during development,
     it is recommended to set a breakpoint on the following instruction.
  */
}
/**
  * @brief FLASH Interrupt routine.
  * @param  None
  * @retval None
  */
INTERRUPT_HANDLER(FLASH_IRQHandler, 1)
{
  /* In order to detect unexpected events during development,
     it is recommended to set a breakpoint on the following instruction.
  */
}
/**
  * @brief DMA1 channel0 and channel1 Interrupt routine.
  * @param  None
  * @retval None
  */
INTERRUPT_HANDLER(DMA1_CHANNEL0_1_IRQHandler, 2)
{
  /* In order to detect unexpected events during development,
     it is recommended to set a breakpoint on the following instruction.
  */
}
/**
  * @brief DMA1 channel2 and channel3 Interrupt routine.
  * @param  None
  * @retval None
  */
INTERRUPT_HANDLER(DMA1_CHANNEL2_3_IRQHandler, 3)
{
  /* In order to detect unexpected events during development,
     it is recommended to set a breakpoint on the following instruction.
  */
}
/**
  * @brief RTC / CSS_LSE Interrupt routine.
  * @param  None
  * @retval None
  */
INTERRUPT_HANDLER(RTC_CSSLSE_IRQHandler, 4)
{
  /* In order to detect unexpected events during development,
     it is recommended to set a breakpoint on the following instruction.
  */
}
/**
  * @brief External IT PORTE/F and PVD Interrupt routine.
  * @param  None
  * @retval None
  */
INTERRUPT_HANDLER(EXTIE_F_PVD_IRQHandler, 5)
{
  /* In order to detect unexpected events during development,
     it is recommended to set a breakpoint on the following instruction.
  */
}

/**
  * @brief External IT PORTB / PORTG Interrupt routine.
  * @param  None
  * @retval None
  */
INTERRUPT_HANDLER(EXTIB_G_IRQHandler, 6)
{
  /* In order to detect unexpected events during development,
     it is recommended to set a breakpoint on the following instruction.
  */
}

/**
  * @brief External IT PORTD /PORTH Interrupt routine.
  * @param  None
  * @retval None
  */
INTERRUPT_HANDLER(EXTID_H_IRQHandler, 7)
{
  /* In order to detect unexpected events during development,
     it is recommended to set a breakpoint on the following instruction.
  */
}

/**
  * @brief External IT PIN0 Interrupt routine.
  * @param  None
  * @retval None
  */
INTERRUPT_HANDLER(EXTI0_IRQHandler, 8)
{
  /* In order to detect unexpected events during development,
     it is recommended to set a breakpoint on the following instruction.
  */
}

/**
  * @brief External IT PIN1 Interrupt routine.
  * @param  None
  * @retval None
  */
INTERRUPT_HANDLER(EXTI1_IRQHandler, 9)
{
  /* In order to detect unexpected events during development,
     it is recommended to set a breakpoint on the following instruction.
  */
}

/**
  * @brief External IT PIN2 Interrupt routine.
  * @param  None
  * @retval None
  */
INTERRUPT_HANDLER(EXTI2_IRQHandler, 10)
{
  /* In order to detect unexpected events during development,
     it is recommended to set a breakpoint on the following instruction.
  */
}

/**
  * @brief External IT PIN3 Interrupt routine.
  * @param  None
  * @retval None
  */
INTERRUPT_HANDLER(EXTI3_IRQHandler, 11)
{
  /* In order to detect unexpected events during development,
     it is recommended to set a breakpoint on the following instruction.
  */
}

/**
  * @brief External IT PIN4 Interrupt routine.
  * @param  None
  * @retval None
  */
INTERRUPT_HANDLER(EXTI4_IRQHandler, 12)
{
  /* In order to detect unexpected events during development,
     it is recommended to set a breakpoint on the following instruction.
  */
}

/**
  * @brief External IT PIN5 Interrupt routine.
  * @param  None
  * @retval None
  */
INTERRUPT_HANDLER(EXTI5_IRQHandler, 13)
{
  /* In order to detect unexpected events during development,
     it is recommended to set a breakpoint on the following instruction.
  */
}

/**
  * @brief External IT PIN6 Interrupt routine.
  * @param  None
  * @retval None
  */
INTERRUPT_HANDLER(EXTI6_IRQHandler, 14)
{
  /* In order to detect unexpected events during development,
     it is recommended to set a breakpoint on the following instruction.
  */
}

/**
  * @brief External IT PIN7 Interrupt routine.
  * @param  None
  * @retval None
  */
INTERRUPT_HANDLER(EXTI7_IRQHandler, 15)
{
  /* In order to detect unexpected events during development,
     it is recommended to set a breakpoint on the following instruction.
  */
}
/**
  * @brief LCD /AES Interrupt routine.
  * @param  None
  * @retval None
  */
INTERRUPT_HANDLER(LCD_AES_IRQHandler, 16)
{
  /* In order to detect unexpected events during development,
     it is recommended to set a breakpoint on the following instruction.
  */
}
/**
  * @brief CLK switch/CSS/TIM1 break Interrupt routine.
  * @param  None
  * @retval None
  */
INTERRUPT_HANDLER(SWITCH_CSS_BREAK_DAC_IRQHandler, 17)
{
  /* In order to detect unexpected events during development,
     it is recommended to set a breakpoint on the following instruction.
  */
}

/**
  * @brief ADC1/Comparator Interrupt routine.
  * @param  None
  * @retval None
  */
INTERRUPT_HANDLER(ADC1_COMP_IRQHandler, 18)
{
  /* In order to detect unexpected events during development,
     it is recommended to set a breakpoint on the following instruction.
  */
}

/**
  * @brief TIM2 Update/Overflow/Trigger/Break /USART2 TX Interrupt routine.
  * @param  None
  * @retval None
  */
INTERRUPT_HANDLER(TIM2_UPD_OVF_TRG_BRK_USART2_TX_IRQHandler, 19)
{
  /* In order to detect unexpected events during development,
     it is recommended to set a breakpoint on the following instruction.
  */
}

/**
  * @brief Timer2 Capture/Compare / USART2 RX Interrupt routine.
  * @param  None
  * @retval None
  */
INTERRUPT_HANDLER(TIM2_CC_USART2_RX_IRQHandler, 20)
{
  /* In order to detect unexpected events during development,
     it is recommended to set a breakpoint on the following instruction.
  */
}


/**
  * @brief Timer3 Update/Overflow/Trigger/Break Interrupt routine.
  * @param  None
  * @retval None
  */
INTERRUPT_HANDLER(TIM3_UPD_OVF_TRG_BRK_USART3_TX_IRQHandler, 21)
{
  /* In order to detect unexpected events during development,
     it is recommended to set a breakpoint on the following instruction.
  */
}
/**
  * @brief Timer3 Capture/Compare /USART3 RX Interrupt routine.
  * @param  None
  * @retval None
  */
INTERRUPT_HANDLER(TIM3_CC_USART3_RX_IRQHandler, 22)
{
  /* In order to detect unexpected events during development,
     it is recommended to set a breakpoint on the following instruction.
  */
}
/**
  * @brief TIM1 Update/Overflow/Trigger/Commutation Interrupt routine.
  * @param  None
  * @retval None
  */
INTERRUPT_HANDLER(TIM1_UPD_OVF_TRG_COM_IRQHandler, 23)
{
  /* In order to detect unexpected events during development,
     it is recommended to set a breakpoint on the following instruction.
  */
  if (step == 1)
  {
    // Next step: Step 2 Configuration ---------------------------- 
    // Channel1 configuration 
    TIM1_SelectOCxM(TIM1_Channel_1, TIM1_OCMode_PWM1);
    TIM1_CCxCmd(TIM1_Channel_1, ENABLE);
    TIM1_CCxNCmd(TIM1_Channel_1, DISABLE);

    // Channel2 configuration 
    TIM1_SelectOCxM(TIM1_Channel_2, TIM1_OCMode_PWM1);
    TIM1_CCxCmd(TIM1_Channel_2, DISABLE);
    TIM1_CCxNCmd(TIM1_Channel_2, ENABLE);

    // Channel3 configuration 
    TIM1_CCxCmd(TIM1_Channel_3, DISABLE);
    TIM1_CCxNCmd(TIM1_Channel_3, DISABLE);

    step++;
  }
  else if (step == 2)
  {
    // Next step: Step 3 Configuration ---------------------------- 
    // Channel1 configuration 
    TIM1_CCxCmd(TIM1_Channel_1, DISABLE);
    TIM1_CCxNCmd(TIM1_Channel_1, DISABLE);

    // Channel2 configuration 
    TIM1_SelectOCxM(TIM1_Channel_2, TIM1_OCMode_PWM1);
    TIM1_CCxCmd(TIM1_Channel_2, DISABLE);
    TIM1_CCxNCmd(TIM1_Channel_2, ENABLE);

    // Channel3 configuration 
    TIM1_SelectOCxM(TIM1_Channel_3, TIM1_OCMode_PWM1);
    TIM1_CCxCmd(TIM1_Channel_3, ENABLE);
    TIM1_CCxNCmd(TIM1_Channel_3, DISABLE);

    step++;
  }
  else if (step == 3)
  {
    // Next step: Step 4 Configuration ---------------------------- 
    // Channel1 configuration 
    TIM1_SelectOCxM(TIM1_Channel_1, TIM1_OCMode_PWM1);
    TIM1_CCxCmd(TIM1_Channel_1, DISABLE);
    TIM1_CCxNCmd(TIM1_Channel_1, ENABLE);

    // Channel2 configuration 
    TIM1_CCxCmd(TIM1_Channel_2, DISABLE);
    TIM1_CCxNCmd(TIM1_Channel_2, DISABLE);

    // Channel3 configuration 
    TIM1_SelectOCxM(TIM1_Channel_3, TIM1_OCMode_PWM1);
    TIM1_CCxCmd(TIM1_Channel_3, ENABLE);
    TIM1_CCxNCmd(TIM1_Channel_3, DISABLE);

    step++;
  }
  else if (step == 4)
  {
    // Next step: Step 5 Configuration ---------------------------- 
    // Channel1 configuration 
    TIM1_SelectOCxM(TIM1_Channel_1, TIM1_OCMode_PWM1);
    TIM1_CCxCmd(TIM1_Channel_1, DISABLE);
    TIM1_CCxNCmd(TIM1_Channel_1, ENABLE);

    // Channel2 configuration 
    TIM1_SelectOCxM(TIM1_Channel_2, TIM1_OCMode_PWM1);
    TIM1_CCxCmd(TIM1_Channel_2, ENABLE);
    TIM1_CCxNCmd(TIM1_Channel_2, DISABLE);

    // Channel3 configuration 
    TIM1_CCxCmd(TIM1_Channel_3, DISABLE);
    TIM1_CCxNCmd(TIM1_Channel_3, DISABLE);

    step++;
  }
  else if (step == 5)
  {
    // Next step: Step 6 Configuration ---------------------------- 
    // Channel1 configuration 
    TIM1_CCxCmd(TIM1_Channel_1, DISABLE);
    TIM1_CCxNCmd(TIM1_Channel_1, DISABLE);

    // Channel2 configuration 
    TIM1_SelectOCxM(TIM1_Channel_2, TIM1_OCMode_PWM1);
    TIM1_CCxCmd(TIM1_Channel_2, ENABLE);
    TIM1_CCxNCmd(TIM1_Channel_2, DISABLE);

    // Channel3 configuration 
    TIM1_SelectOCxM(TIM1_Channel_3, TIM1_OCMode_PWM1);
    TIM1_CCxCmd(TIM1_Channel_3, DISABLE);
    TIM1_CCxNCmd(TIM1_Channel_3, ENABLE);

    step++;
  }
  else
  {
    // Next step: Step 1 Configuration ---------------------------- 
    // Channel1 configuration 
    TIM1_SelectOCxM(TIM1_Channel_1, TIM1_OCMode_PWM1);
    TIM1_CCxCmd(TIM1_Channel_1, ENABLE);
    TIM1_CCxNCmd(TIM1_Channel_1, DISABLE);

    // Channel2 configuration 
    TIM1_CCxCmd(TIM1_Channel_2, DISABLE);
    TIM1_CCxNCmd(TIM1_Channel_2, DISABLE);

    // Channel3 configuration 
    TIM1_SelectOCxM(TIM1_Channel_3, TIM1_OCMode_PWM1);
    TIM1_CCxCmd(TIM1_Channel_3, DISABLE);
    TIM1_CCxNCmd(TIM1_Channel_3, ENABLE);

    step = 1;
  }

  // Clear Interrupt pending bit 
  TIM1_ClearITPendingBit(TIM1_IT_COM);
}
/**
  * @brief TIM1 Capture/Compare Interrupt routine.
  * @param  None
  * @retval None
  */
INTERRUPT_HANDLER(TIM1_CC_IRQHandler, 24)
{
  /* In order to detect unexpected events during development,
     it is recommended to set a breakpoint on the following instruction.
  */
}

/**
  * @brief TIM4 Update/Overflow/Trigger Interrupt routine.
  * @param  None
  * @retval None
  */
INTERRUPT_HANDLER(TIM4_UPD_OVF_TRG_IRQHandler, 25)
{
  /* In order to detect unexpected events during development,
     it is recommended to set a breakpoint on the following instruction.
  */
  if (TimeCounter == 11)
  {
    // Generate TIM1 COM event by software 
    TIM1_GenerateEvent(TIM1_EventSource_COM);
    TimeCounter = 1;
    /* TIM4 Update Interrupt occurs each 16,384 ms = (Period * Prescaler)/SYSCLK
                                                  = (256*128)/2Mhz = 16,384 ms
    so after 11 Update Interrupts, 180 ms have been spent (11 * 16,384  = 180.2 ms)
    there a commutation event generated by oftware */
  }
  else
  {
    TimeCounter++;
  }
  // Clear Interrupt Pending bit 
  TIM4_ClearITPendingBit(TIM4_IT_Update);
}
/**
  * @brief SPI1 Interrupt routine.
  * @param  None
  * @retval None
  */
INTERRUPT_HANDLER(SPI1_IRQHandler, 26)
{
  /* In order to detect unexpected events during development,
     it is recommended to set a breakpoint on the following instruction.
  */
}

/**
  * @brief USART1 TX / TIM5 Update/Overflow/Trigger/Break Interrupt  routine.
  * @param  None
  * @retval None
  */
INTERRUPT_HANDLER(USART1_TX_TIM5_UPD_OVF_TRG_BRK_IRQHandler, 27)
{
  /* In order to detect unexpected events during development,
     it is recommended to set a breakpoint on the following instruction.
  */
}

/**
  * @brief USART1 RX / Timer5 Capture/Compare Interrupt routine.
  * @param  None
  * @retval None
  */
INTERRUPT_HANDLER(USART1_RX_TIM5_CC_IRQHandler, 28)
{
  /* In order to detect unexpected events during development,
     it is recommended to set a breakpoint on the following instruction.
  */
}

/**
  * @brief I2C1 / SPI2 Interrupt routine.
  * @param  None
  * @retval None
  */
INTERRUPT_HANDLER(I2C1_SPI2_IRQHandler, 29)
{
  /* In order to detect unexpected events during development,
     it is recommended to set a breakpoint on the following instruction.
  */
}


